<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SimpleEventCache.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.event</a> &gt; <span class="el_source">SimpleEventCache.java</span></div><h1>SimpleEventCache.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.event;

import io.gitlab.littlesaints.protean.EventExecutor;
import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.configuration.Props;
import io.gitlab.littlesaints.protean.resources.Registrar;
import io.gitlab.littlesaints.protean.throttle.Throttle;

import java.util.concurrent.Semaphore;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicReferenceArray;
import java.util.function.Function;
import java.util.stream.IntStream;

/**
 * A minimal Events cache used by the {@link EventExecutor}, if it's configured for caching. This acts as a implicit {@link Throttle} as well.
 */
public class SimpleEventCache&lt;E&gt; implements EventCache&lt;E&gt; {

	public static final String TYPE = &quot;protean::event::cache::simple&quot;;

<span class="fc" id="L42">	public static class _Registrar implements Registrar {</span>
		static {
<span class="fc" id="L44">			REGISTRY.register(TYPE, SimpleEventCache::new);</span>
<span class="fc" id="L45">		}</span>

		@Override
		public String toString() {
<span class="fc" id="L49">			return &quot;EventCache::Registrar&quot;;</span>
		}
	}

	private static final String POOL_INDEX_PROP = &quot;contextPoolIndex&quot;;

	private final AtomicReferenceArray&lt;Boolean&gt; usedEventIndexes;

	private final E[] events;

	private final int capacity;

	private AtomicInteger nextFetchIndex;

	private final EventAccessor&lt;E, ?&gt; eventAccessor;

	private final Semaphore permits;

<span class="nc" id="L67">	public SimpleEventCache(Config config, int capacity, Function&lt;Props, E&gt; constructor, EventAccessor&lt;E, ?&gt; eventAccessor) {</span>
<span class="nc" id="L68">        this.capacity = capacity;</span>
<span class="nc" id="L69">	    permits = new Semaphore(capacity);</span>
<span class="nc" id="L70">		events = (E[]) new Object[capacity];</span>
<span class="nc" id="L71">		usedEventIndexes = new AtomicReferenceArray&lt;&gt;(capacity);</span>
<span class="nc" id="L72">		IntStream.range(0, capacity).forEach(i -&gt; {</span>
<span class="nc" id="L73">			Props props = new Props();</span>
<span class="nc" id="L74">			props.put(POOL_INDEX_PROP, i);</span>
<span class="nc" id="L75">			events[i] = constructor.apply(props);</span>
<span class="nc" id="L76">			usedEventIndexes.set(i, false);</span>
<span class="nc" id="L77">		});</span>
<span class="nc" id="L78">		nextFetchIndex = new AtomicInteger();</span>
<span class="nc" id="L79">		this.eventAccessor = eventAccessor;</span>
<span class="nc" id="L80">	}</span>

	@Override
	public E get() {
		while (true) {
            try {
<span class="nc" id="L86">                permits.acquire();</span>
<span class="nc" id="L87">                break;</span>
<span class="nc" id="L88">            } catch (InterruptedException e) {</span>
                //TODO: log error
<span class="nc" id="L90">            }</span>
        }
        E event;
<span class="nc bnc" id="L93" title="All 2 branches missed.">        while ((event = tryGet()) == null);</span>
<span class="nc" id="L94">		return event;</span>
	}

	@Override
	public E tryGet() {
<span class="nc" id="L99">		int idx = nextFetchIndex.get();</span>
<span class="nc bnc" id="L100" title="All 2 branches missed.">		for (int counter = 0; counter &lt; capacity; counter++, idx++) {</span>
<span class="nc bnc" id="L101" title="All 2 branches missed.">			if (!usedEventIndexes.get(idx)) {</span>
<span class="nc bnc" id="L102" title="All 2 branches missed.">				if (usedEventIndexes.compareAndSet(idx, false, true)) {</span>
<span class="nc bnc" id="L103" title="All 2 branches missed.">					nextFetchIndex.lazySet(idx + 1 == capacity ? 0 : idx + 1);</span>
<span class="nc" id="L104">					return events[idx];</span>
				}
<span class="nc bnc" id="L106" title="All 2 branches missed.">			} else if (idx == capacity - 1) {</span>
<span class="nc" id="L107">				idx = -1;</span>
			}
		}
<span class="nc" id="L110">		return null;</span>
	}

	@Override
	public void put(E event) {
<span class="nc" id="L115">		usedEventIndexes.set(eventAccessor.getConf(event, POOL_INDEX_PROP), false);</span>
<span class="nc" id="L116">		permits.release();</span>
<span class="nc" id="L117">	}</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>